VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Listscr5 sample from BlackBeltVB.com"
   ClientHeight    =   3345
   ClientLeft      =   1725
   ClientTop       =   1935
   ClientWidth     =   6450
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3345
   ScaleWidth      =   6450
   Begin VB.ListBox List2 
      Height          =   2400
      Left            =   3240
      TabIndex        =   1
      Top             =   300
      Width           =   2355
   End
   Begin VB.ListBox List1 
      Height          =   2400
      Left            =   420
      TabIndex        =   0
      Top             =   300
      Width           =   2415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Listscr5 sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 1999 by Matt Hart
' 
' This software is FREEWARE. You may use it as you see fit for 
' your own projects but you may not re-sell the original or the 
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/listscr5.htm"
' 
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.
'
' This sample shows you how to get a horizontal scroll bar in a list box.
' It also subclasses a list box to provide a horizontal scroll message.
' Note that I store the original WndProc address in the UserData area of the
' ListBox. This allows a single WndProc procedure to handle all controls.

Const LB_DIR = &H18D
Const LB_SETHORIZONTALEXTENT = &H194
' DlgDirList, DlgDirListComboBox flags values
Const DDL_READWRITE = &H0
Const DDL_READONLY = &H1
Const DDL_HIDDEN = &H2
Const DDL_SYSTEM = &H4
Const DDL_DIRECTORY = &H10
Const DDL_ARCHIVE = &H20

Const DDL_POSTMSGS = &H2000
Const DDL_DRIVES = &H4000
Const DDL_EXCLUSIVE = &H8000

Private Sub Form_Load()
    Call FillList(List1, "c:\windows\*.*", 0)
    Call FillList(List2, "c:\windows\*.*", DDL_DIRECTORY)
    SetWindowLong List1.hwnd, GWL_USERDATA, SetWindowLong(List1.hwnd, GWL_WNDPROC, AddressOf WndProc)
    SetWindowLong List2.hwnd, GWL_USERDATA, SetWindowLong(List2.hwnd, GWL_WNDPROC, AddressOf WndProc)
End Sub

Private Sub FillList(LB As ListBox, aPath$, uFlags As Long)
    Dim l As Long, w As Long, k As Long
    
    ' Fill List box with data
    l = SendMessage(LB.hwnd, LB_DIR, uFlags, ByVal aPath$)
    
    ' If it's a Dir box, remove file entries
    If uFlags And DDL_DIRECTORY Then
        l = 0
        Do Until l >= LB.ListCount
            If Left$(LB.List(l), 1) <> "[" Then
                LB.RemoveItem l
            Else
                l = l + 1
            End If
        Loop
    End If
    
    ' Calculate max width needed
    Dim F As Form
    Set F = Me
    Set F.Font = LB.Font
    For l = 0 To LB.ListCount - 1
        LB.List(l) = Left$(aPath$, InStr(aPath$, "*") - 1) & LB.List(l)
        k = F.TextWidth(LB.List(l))
        If k > w Then w = k
    Next
    
    Set F = Nothing
    
    ' Convert to pixels and set the LB scroll size.  If scroll size is >
    ' visible size, then the horiz scroll bar will appear
    w = w \ Screen.TwipsPerPixelX
    l = SendMessage(LB.hwnd, LB_SETHORIZONTALEXTENT, w, ByVal 0)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SetWindowLong List1.hwnd, GWL_WNDPROC, GetWindowLong(List1.hwnd, GWL_USERDATA)
    SetWindowLong List2.hwnd, GWL_WNDPROC, GetWindowLong(List2.hwnd, GWL_USERDATA)
End Sub

Private Sub List1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button > 0 And X < 0 And Y < 0 Then Debug.Print "List1 Horizontal Scroll"
End Sub

Private Sub List2_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button > 0 And X < 0 And Y < 0 Then Debug.Print "List2 Horizontal Scroll"
End Sub
